/*******************************************************************************
 * <copyright>
 * Copyright (c) 1995, 2015 Technische Universität Berlin. All rights reserved. 
 * This program and the accompanying materials are made available 
 * under the terms of the Eclipse Public License v1.0 which 
 * accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * </copyright>
 *******************************************************************************/
package agg.attribute.impl;

/**
 * This interface sets some constants for status codes.
 * 
 * @version $Id: AttrMsgCode.java,v 1.2 2007/09/10 13:05:18 olga Exp $
 * @author $Author: olga $
 */
public interface AttrMsgCode {

	static public final int OK = 0;

	static public final int NO_SUCH_TYPE = 1;

	static public final int NAME_DUPLICATION = 2;

	static public final int BAD_EXPR_TYPE = 3;

	static public final int EXPR_MUST_BE_CONST = 4;

	static public final int EXPR_MUST_BE_CONST_OR_VAR = 5;

	static public final int VAR_NOT_DECLARED = 6;

	static public final int EXPR_PARSE_ERR = 7;

	static public final int EXPR_EVAL_ERR = 8;

	static public final int ATTR_DONT_MATCH = 9;

	static public final int RULE_SOURCES_DIFFER = 10;

	static public final int MATCH_TARGETS_DIFFER = 11;

	static public final int NO_SUCH_NAME = 12;

	static public final int EXPR_REQUIRED = 13;
}

/*
 * $Log: AttrMsgCode.java,v $
 * Revision 1.2  2007/09/10 13:05:18  olga
 * In this update:
 * - package xerces2.5.0 is not used anymore;
 * - class com.objectspace.jgl.Pair is replaced by the agg own generic class agg.util.Pair;
 * - bugs fixed in:  usage of PACs in rules;  match completion;
 * 	usage of static method calls in attr. conditions
 * - graph editing: added some new features
 * Revision 1.1 2005/08/25 11:56:57 enrico *** empty
 * log message ***
 * 
 * Revision 1.1 2005/05/30 12:58:04 olga Version with Eclipse
 * 
 * Revision 1.2 2002/09/23 12:23:54 komm added type graph in xt_basis, editor
 * and GUI
 * 
 * Revision 1.1.1.1 2002/07/11 12:17:01 olga Imported sources
 * 
 * Revision 1.4 2000/04/05 12:08:54 shultzke serialVersionUID aus V1.0.0
 * generiert
 * 
 */
