/*******************************************************************************
 * <copyright>
 * Copyright (c) 1995, 2015 Technische Universität Berlin. All rights reserved. 
 * This program and the accompanying materials are made available 
 * under the terms of the Eclipse Public License v1.0 which 
 * accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * </copyright>
 *******************************************************************************/
/**
 * 
 */
package agg.gui.treeview.nodedata;


import javax.swing.tree.DefaultMutableTreeNode;

import agg.attribute.impl.CondMember;
import agg.cons.Formula;
import agg.editor.impl.EdAtomApplCond;
import agg.editor.impl.EdAtomic;
import agg.editor.impl.EdConstraint;
import agg.editor.impl.EdGraGra;
import agg.editor.impl.EdGraph;
import agg.editor.impl.EdNAC;
import agg.editor.impl.EdNestedApplCond;
import agg.editor.impl.EdPAC;
import agg.editor.impl.EdRule;
import agg.editor.impl.EdRuleConstraint;
import agg.editor.impl.EdRuleScheme;
import agg.ruleappl.RuleSequence;
import agg.util.Pair;

/**
 * @author olga
 *
 */
public abstract class GraGraTreeNodeDataAdapter implements GraGraTreeNodeData {

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#dispose()
	 */
	public void dispose() {
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getAtomApplCond()
	 */
	public EdAtomApplCond getAtomApplCond() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getAtomic()
	 */
	public EdAtomic getAtomic() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getAttrCondition()
	 */
	public Pair<CondMember, EdRule> getAttrCondition() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getConclusion()
	 */
	public EdAtomic getConclusion() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getConstraint()
	 */
	public EdConstraint getConstraint() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getData()
	 */
	public Object getData() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getGraGra()
	 */
	public EdGraGra getGraGra() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getGraph()
	 */
	public EdGraph getGraph() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getNAC()
	 */
	public EdNAC getNAC() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getPAC()
	 */
	public EdPAC getPAC() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getRule()
	 */
	public EdRule getRule() {
		return null;
	}

	public Formula getFormula() {
		return null;
	}
	
	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getRuleConstraint()
	 */
	public EdRuleConstraint getRuleConstraint() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getTreeNode()
	 */
	public DefaultMutableTreeNode getTreeNode() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isAtomApplCond()
	 */
	public boolean isAtomApplCond() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isAtomic()
	 */
	public boolean isAtomic() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isAttrCondition()
	 */
	public boolean isAttrCondition() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isConclusion()
	 */
	public boolean isConclusion() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isConstraint()
	 */
	public boolean isConstraint() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isGraGra()
	 */
	public boolean isGraGra() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isGraph()
	 */
	public boolean isGraph() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isNAC()
	 */
	public boolean isNAC() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isPAC()
	 */
	public boolean isPAC() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isRule()
	 */
	public boolean isRule() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isRuleConstraint()
	 */
	public boolean isRuleConstraint() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isTypeGraph()
	 */
	public boolean isTypeGraph() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#setData(java.lang.Object)
	 */
	public void setData(Object obj) {
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#setString(java.lang.String, java.lang.String, java.lang.String)
	 */
	public void setString(String tag, String tag1, String newString) {
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#setString(java.lang.String, java.lang.String)
	 */
	public void setString(String tag, String newString) {
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#setString(java.lang.String)
	 */
	public void setString(String str) {
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#setTreeNode(javax.swing.tree.DefaultMutableTreeNode)
	 */
	public void setTreeNode(DefaultMutableTreeNode node) {
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#string()
	 */
	public String string() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#update()
	 */
	public void update() {
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getRuleScheme()
	 */
	public EdRuleScheme getRuleScheme() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isRuleScheme()
	 */
	public boolean isRuleScheme() {
		return false;
	}
	
	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isKernelRule()
	 */
	public boolean isKernelRule() {
		return false;
	}
	
	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getKernelRule()
	 */
	public EdRule getKernelRule() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isMultiRule()
	 */
	public boolean isMultiRule() {
		return false;
	}
	
	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getMultiRule()
	 */
	public EdRule getMultiRule() {
		return null;
	}
	
	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isAmalgamatedRule()
	 */
	public boolean isAmalgamatedRule() {
		return false;
	}
	
	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getAmalgamatedRule()
	 */
	public EdRule getAmalgamatedRule() {
		return null;
	}
	
	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#isRuleSequence()
	 */
	public boolean isRuleSequence() {
		return false;
	}
	
	/* (non-Javadoc)
	 * @see agg.gui.treeview.GraGraTreeNodeData#getRuleSequence()
	 */
	public RuleSequence getRuleSequence() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.nodedata.GraGraTreeNodeData#isNestedAC()
	 */
	public boolean isNestedAC() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.nodedata.GraGraTreeNodeData#getNestedAC()
	 */
	public EdNestedApplCond getNestedAC() {
		return null;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.nodedata.GraGraTreeNodeData#isApplFormula()
	 */
	public boolean isApplFormula() {
		return false;
	}

	/* (non-Javadoc)
	 * @see agg.gui.treeview.nodedata.GraGraTreeNodeData#getToolTipText()
	 */
	public String getToolTipText() {
		return "";
	}

	public boolean isTreeTextEditable() {
		return true;
	}
	
}
